/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "update_funds.h"

char *emonth_name[]=\
{"illegal","Jan","Feb","Mar","Apr","Mai","Jun","Jul",\
"Aug","Sep","Oct","Nov","Dec"};

char *url;
char *datadir;


int main(int argc, char **argv)
{
struct passwd *userinfo;
int a;
char *local_filename;
int get_flag;
int update_flag;

/*select con io 1 byte at the time*/
setbuf(stdout,NULL);
setbuf(stdin,NULL);

/* set io permissions */
ioperm(0x40, 0x3bf, 1);

fprintf(stdout, "Panteltje(c) update_funds-0.6\n");

local_filename = strsave("");
if(! local_filename)
	{
	fprintf(stdout, "main(): malloc failed\n");
	exit(1);
	}

/* set default */
/*free(url);*/
url = strsave("http://www.quoteweb.com/download/free/davieff");
if(! url)
	{
	fprintf(stdout,\
	"main(): cannot allocate space for url\n");
	exit(1);
	}

datadir = strsave(DATADIR);
if(! datadir)
	{
	fprintf(stdout, "main(): cannot allocate space for datadir\n");
	return 0;
	}

debug_flag = 0;
get_flag = 0;
update_flag = 0;
while(1)
	{
	a = getopt(argc, argv, "dhgu");
	if(a == -1) break;

	switch(a)
		{
        case -1:
        	break;
        case 'd':
			debug_flag = 1;
			break;
		case 'g':
			get_flag = 1;
			break;
		case 'h':
			fprintf(stdout,\
"Usage: update_funds [-d] [-h] [-g] [-u]\n\
\t-d       print debug messages (o.a. function calls and arguments).\n\
\t-g       get the files from the net to local disk.\n\
\t-h       help (this help).\n\
\t-u       update the .krs files from the data obtained using the -g flag.\n");
			exit(1);
			break;
		case 'u':
			update_flag = 1;
			break;
		case '?':
			if (isprint(optopt) )
 				{
 				fprintf(stdout, "Unknown option `-%c'.\n", optopt);
 				}
			else
				{
				fprintf(stdout, "Unknown option character `\\x%x'.\n",\
				optopt);
				}
			exit(1);
			break;			
		default:
			break;
		}/* end switch a */
	}/* end while getopt() */

/* get user info */
userinfo = getpwuid(getuid() );

/* get home directory */ 
home_dir = strsave(userinfo -> pw_dir);
if(! home_dir)
	{
	fprintf(stdout, "main(): cannot get home_dir, malloc failed\n");
	exit(1);
	}

/* get user name */
user_name = strsave(userinfo -> pw_name);
if(! user_name)
	{
	fprintf(stdout, "main(): cannot get user_name, malloc failed\n");
	exit(1);
	}

fprintf(stdout, "main(): filling database\n");
if(! fill_database(local_filename, get_flag, update_flag) )
	{
	fprintf(stdout, "Could not fill database, aborted\n");
	exit(1);
	}
free(local_filename);

fprintf(stdout, "main(): updating funds\n");
if(! update_all_funds() )
	{
	fprintf(stdout, "Could not update funds\n");	
	exit(1);
	}

fprintf(stdout, "Ready\n");
exit(1);
}/* end function main */


int fill_database(char *filename, int get_flag, int update_flag)
{
int a, i;
char temp[READSIZE];
char temp2[READSIZE];
FILE *fptr;
char datestr1[20];
char datestr2[20];
char weekday[20];
char monthstr[20];
int year, month, monthday, hour, minute, second;
char *ptr1;

if(debug_flag)
	{
	fprintf(stdout,\
	"fill_database(): arg filename=%s get_flag=%d update_flag=%d\n",\
	filename, get_flag, update_flag);
	}

if(! filename) return(0);

ogettime(weekday, monthstr, &monthday, &hour, &minute, &second, &year);
/* 19981106.csv */

month = -1;
for(i = 0; i <= 12; i++)/* 0 is illegal, 12 is dec */
	{
	if(strcmp(monthstr, emonth_name[i]) == 0)
		{
		month = i;
		break;
		}
	}
if(month == -1)	
	{
	sprintf(temp,\
	"fill_database(): invalide month %s\n", monthstr);
	return(0);
	}

sprintf(datestr1, "%2d%02d%02d", year % 100, month, monthday);
sprintf(datestr2, "%4d%02d%02d", year, month, monthday);

/* get the file with the link to what we want :) */
if(get_flag)
	{
	sprintf(temp,\
	"/usr/local/bin/urlget www.beurs.nl/download/ > %s/download.html",\
	datadir);

	/*	url, datestr1);  */
	fprintf(stdout, "executing: %s\n", temp);
	fptr = popen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp); 
		return 0;
		}
	pclose(fptr);

	/* extract the line that holds the shares link in davieff format */
	sprintf(temp,\
	"grep davieff %s/download.html > %s/shares_link",\
	datadir, datadir);
	fprintf(stdout, "executing: %s\n", temp);
	fptr = popen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp); 
		return 0;
		}
	pclose(fptr);

	/* extract the line that holds the options link in davieff format */
	sprintf(temp,\
	"grep csv %s/download.html > %s/options_link",\
	datadir, datadir);
	fprintf(stdout, "executing: %s\n", temp);
	fptr = popen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp); 
		/* no options, but do not abort */
/*		return 0;*/
		}
	pclose(fptr);

	/*
	This is what we have now:
	shares_link:
	<td width="50%" valign="top"><big><a href="http://www.quoteweb.com/downl
	oad/free/davieff/ul990629.zip">ul990629.zip</a></big></td>
	        
	options_link:	        
	<td width="50%" valign="top"><font size="4"><a href="http://www.quoteweb.
	com/download/free/opties/csv/ul990629.zip">ul990629.zip</a></font></td>

	The problem is in the first letters 'ul' they change every day, probably
	to force you to read their site and avoid the use of automatic download
	programs.
	It could also be some code related to day or date or just a table.
	*/
	
	/* read the shares_link file */
	sprintf(temp, "%s/shares_link", datadir);
	fprintf(stdout, "opening %s for read\n", temp);
	fptr = fopen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot open %s for read\n", temp);
		return 0;
		}

	a = readline(fptr, temp);/* closes file if EOF */
	if(a != EOF) fclose(fptr);

	/* extract the url (shares_link is in temp) */
	ptr1 = strstr(temp, "http:");	
	if(! ptr1)
		{
		fprintf(stdout, "Cannot find 'http:' in shares_link\n");
		return 0;
		}
	strcpy (temp2, ptr1);
	
	/* find the end */
	ptr1 = strchr(temp2, '"');
	if(! ptr1)
		{
		fprintf(stdout,\
		"Cannot find double quote character that ends url in shares_link\n");
		return 0;
		}
	/* mark as end url */
	*ptr1 = 0;
	
	/* get the shares zip file (xx990701.zip)  ! */
	sprintf(temp,\
	"urlget %s > %s/%s.shares.zip",\
	temp2, datadir, datestr2);
	fprintf(stdout, "executing: %s\n", temp);
	fptr = popen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp);
		return 0;
		}

	/* read the options_link file */
	sprintf(temp, "%s/options_link", datadir);
	fptr = fopen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot open %s for read\n", temp);
		return 0;
		}

	a = readline(fptr, temp);/* closes file if EOF */
	if(a != EOF) fclose(fptr);

	ptr1 = strstr(temp, datestr1);
	if(! ptr1)
		{
		fprintf(stdout, "Cannot find %s in options_link\n", datestr1);
		return 0;
		}		
	
	/* extract the url (options_link is in temp) */
	ptr1 = strstr(temp, "http:");		
	if(! ptr1)
		{
		fprintf(stdout, "Cannot find 'http:' in options_link\n");
		return 0;
		}
	strcpy (temp2, ptr1);
	
	/* find the end */
	ptr1 = strchr(temp2, '"');
	if(! ptr1)
		{
		fprintf(stdout,\
		"Cannot find double quote character that ends url in options_link\n");
		return 0;
		}
	/* mark as end url */
	*ptr1 = 0;
	
	/* get the options zip file  (xx990701.zip) ! */
	sprintf(temp,\
	"urlget %s > %s/%s.options.zip", temp2, datadir, datestr2);
	fprintf(stdout, "executing: %s\n", temp);
	fptr = popen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp);
		return 0;
		}
	
	/* test if update needed */
	if(! update_flag) exit(0);

	/*
	Unzip the options file, -o forces overwrite any older files.
	unzip the file into 1990622.CSV
	Unfortunatly this is the same filename as the shares file.
	*/
	sprintf(temp, "unzip -o %s/%s.options.zip", datadir, datestr2);
	fprintf(stdout, "executing: %s\n", temp);
	/* unzip msut be called with "w" else nothing is done by it */
	fptr = popen(temp, "w");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp); 
		return 0;
		}
	pclose(fptr);
	}/* end if get_flag */

if(update_flag)
	{
	/*
	Unzip the shares file, -o forces overwrite any older files.
	unzip the file into 1990622.CSV but how long will they use zipped
	files?.
	*/
	/* -d flag directory where extracted files go, -o flag overwrites */
	sprintf(temp,\
	"unzip -o %s/%s.shares.zip -d %s",\
	datadir, datestr2, datadir);
	fprintf(stdout, "executing: %s\n", temp);
	/* unzip must be called with "w", else nothing is done by it */
	fptr = popen(temp, "w");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp); 
		return 0;
		}
	pclose(fptr);

	/*
	rename the shares file 1990622.CSV to 1990622.CSV.shares,
	else unzipping the options file willl overwrite it (same name).
	*/
	sprintf(temp, "mv %s/%s.CSV %s/%s.CSV.shares",\
	datadir, datestr2, datadir, datestr2);
	fprintf(stdout, "executing %s\n", temp);
	fptr = popen(temp, "r");
	if(! fptr)
		{
		fprintf(stdout, "Cannot execute %s\n", temp);
		return 0;
		}

	/* create correct filename */
	sprintf(temp, "%s/%s.CSV.shares", datadir, datestr2);

	/* parse the file */
	fprintf(stdout, "Parsing %s\n", temp);
	if(! parse_quoteweb_csv_file(temp) ) return(0);

	}/* end if update_flag */

return(1);
}/* end function fill_database */


int update_all_funds()
{
int a;
float close_price;
long volume;
FILE *cmdfptr;
char temp[READSIZE];
char command[512];
char fundname[512];
int monthday, month, year;
char path[READSIZE];

if(debug_flag)
	{
	fprintf(stdout, "update_all_funds(): arg none\n");
	}

if(! get_path_name("acq_command_files_dir", path) ) return(0);
sprintf(temp, "%saacqv.cmd", path);

sprintf(temp, "/root/compile/krs/aacqv.cmd");
cmdfptr = fopen(temp, "r");
if(! cmdfptr)
	{
	fprintf(stdout,\
	"update_all_funds(): cannot open file %s for read\n",\
	temp);
	return(0);
	}

while(1)
	{
	a = readline(cmdfptr, temp);/* closes file */
 	if(a == EOF) break;
	if(debug_flag)
		{
		fprintf(stdout, "readline=%s\n", temp);
		}

	/* make sure argument empty, else empty line before this one repeated */
	strcpy(command, "");
	sscanf(temp, "%s %s", command, fundname);
	if(atoi(command) == 1135)
		{
		if(debug_flag)
			{
			fprintf(stdout,\
			"update_all_funds(): updating fund=%s\n", fundname);
			}

		/* for all funds in aacqv.cmd */
		/* get close price and volume from for database */

		if(get_fund_from_database(\
		fundname, &close_price, &volume, &monthday, &month, &year) )
			{
			fprintf(stdout, "Updating %s\n", fundname);

			if(! update_fund_file(\
			fundname, close_price, volume, monthday, month, year) )
				{
				fprintf(stdout,\
				"update_all_funds(): could not update_fund_file %s\n",\
				fundname);
				continue;
				}
			}/* end if data in database */
		else
			{
			fprintf(stdout,\
			"update_all_funds(): Cannot find fund %s in database\n",\
			fundname);	
			beep(1, 3000);
			beep(1, 4000);
			}
		}/* end if command is 1135 */

	}/* end while all commands in aacqv.cmd */

return(1);
}/* end fuction update_all_funds */


